#pragma once

#include "ehs/EHS.h"
#include "ehs/Str.h"

namespace ehs
{
	class EHS_LIB_IO Button
	{
	private:
		UInt_32 hash;
		Str_8 name;

	public:
		Button();

		Button(Str_8 name);

		Button(Button &&key) noexcept;

		Button(const Button &key);

		Button &operator=(Button &&key) noexcept;

		Button &operator=(const Button &key);

		bool operator==(const Button &key) const;

		bool operator!=(const Button &key) const;

		UInt_32 GetHash() const;

		Str_8 GetName() const;

		bool IsValid() const;
	};
}
